import { forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

function provideValueAccessor(fn, fieldSelector) {
    return {
        provide: NG_VALUE_ACCESSOR,
        useFactory: (component) => (fieldSelector === undefined || fieldSelector === null) ? component
            : (accessor => ({
                registerOnChange: cvaFn => accessor().registerOnChange(cvaFn),
                registerOnTouched: cvaFn => accessor().registerOnTouched(cvaFn),
                writeValue: value => accessor().writeValue(value),
                setDisabledState: isDisabled => { var _a, _b; return (_b = (_a = accessor()).setDisabledState) === null || _b === void 0 ? void 0 : _b.call(_a, isDisabled); },
            }))(() => typeof fieldSelector === 'function' ? fieldSelector(component)
                : component[fieldSelector]),
        deps: [forwardRef(fn)],
        multi: true,
    };
}

/**
 * Generated bundle index. Do not edit.
 */

export { provideValueAccessor };
//# sourceMappingURL=ngx-reactive-form-utils-provide-value-accessor.js.map
